
## TODO: Replace with library(CSTools) once Alba's fun is merged
library(s2dv)
library(ClimProjDiags)
library(multiApply)
source("https://earth.bsc.es/gitlab/external/cstools/-/raw/develop-CalibrationForecast/R/CST_Calibration.R")

## Entry params data and recipe?
calibrate_datasets <- function(data, recipe) {
  hcst <- data$hcst
  obs <- data$obs
  fcst <- data$fcst
  ## TODO: Implement daily case
  
  # Calibration function params
  method <- recipe$Analysis$Workflow$Calibration$method
  ## TODO: Make sure 'Multimodel' param in recipe is a boolean
  mm <- recipe$Analysis$Datasets$Multimodel
  ncores <- 4
  na.rm <- T
  
  ## TODO: Change or move this check elsewhere so the error shows up earlier
  CST_CALIB_METHODS <- c("bias","evmos","mse_min","crps_min","rpc-based")
  ## TODO: Revise output variable names
  if (method %in% CST_CALIB_METHODS) {
    ## Alba's version
    hcst_calibrated <- CST_Calibration(hcst, obs,
                                       cal.method = method,
                                       eval.method = "leave-one-out",
                                       multi.model = mm,
                                       na.fill = TRUE,
                                       na.rm = na.rm,
                                       apply_to = NULL,
                                       alpha = NULL,
                                       memb_dim = "ensemble",
                                       sdate_dim = "syear",
                                       ncores = ncores)
    ## TODO: Resolve these workarounds
    ## In the new CST_Calibration function, the fcst must have the same number of 
    ## dimensions as the hcst
    if (!is.null(fcst)) {
      dim(fcst$data) <- c(dim(fcst$data)[1:2], "sday" = 1, "sweek" = 1,
      			dim(fcst$data)[3:7])
      ## In the new CST_Calibration function, memb_dim and sdate_dim must be the 
      ## same in the hcst and the fcst.
      names(dim(fcst$data))[which(names(dim(fcst$data)) == 
      		          'fcst_syear')] <- "syear"
      
      fcst_calibrated <- CST_Calibration(hcst, obs, fcst,
                                         cal.method = method,
                                         eval.method = "leave-one-out",
                                         multi.model = mm,
                                         na.fill = TRUE,
                                         na.rm = na.rm,
                                         apply_to = NULL,
                                         alpha = NULL,
                                         memb_dim = "ensemble",
                                         sdate_dim = "syear",
                                         ncores = ncores)
    }
  } else {
    stop("Calibration method is not implemented in CSTools")
  }
  print("###### CALIBRATION COMPLETE ######")
  return(list(hcst_calibrated, fcst_calibrated))
}

#    ## Lluís' version:
#    ## Note: memb_dim is hardcoded as 'ensemble'.
#    source("modules/Calibration/Calibration.R")
#    ## TODO: Change path
#    # source("https://earth.bsc.es/gitlab/api/v4/projects/446/repository/blobs/bfe5848c06536218f1fbed6e9356cc6aebe27762/raw?ref=TFM&private_token=pExJt3V4FYwj4yzvy9ps")
#    source("modules/Calibration/Calibration_fcst3.R")
#    ## TODO: move this elsewhere
#    library(abind)
#    hcst_lluis <- hcst_calib(obs, hcst,
#    			   method = method,
#    			   mm = mm,
#    			   na.rm = na.rm,
#    			   split_factor = 1,
#    			   ncores = ncores)
#  
#    fcst_lluis <- fcst_calib(obs$data, hcst$data, fcst$data,
#  			     # method = method,
#  			     fun = .fcstcal, ## ?
#  			     mm = mm,
#  			     na.rm = na.rm,
#  			     split_factor = 1,
#  			     ncores = ncores)
  
    ## TODO: Include Lluís' forecast version and test it
    # For daily
    # hcst <- CSTools::CST_QuantileMapping(data$hcst,
    #                                      data$obs,
    #                                      exp_cor = NULL,
    #                                      sample_dims = c("syear", "time", "ensemble"),
    #                                      sample_length = NULL,
    #                                      method = "QUANT",
    #                                      ncores = ncores,
    #                                      na.rm = na.rm)
